/* eslint-disable no-case-declarations */
window.assignJob = function assignJob(slave, job) {
	"use strict";
	const V = State.variables;
	let r = "";

	if (job === "Pit" || job === "Coursing Association") { return r; }

	removeJob(slave, slave.assignment);
	const idx = V.slaveIndices[slave.ID];

	/* use .toLowerCase() to get rid of a few dupe conditions. */
	switch (job.toLowerCase()) {
		case "be confined in the arcade":
		case "arcade":
			slave.assignment = "be confined in the arcade";
			slave.assignmentVisible = 0;
			V.arcadeSlaves++;
			V.ArcadeiIDs.push(slave.ID);
			slave.clothes = "no clothing";
			slave.shoes = "none";
			slave.collar = "none";
			slave.livingRules = "spare";
			break;

		case "work in the brothel":
		case "brothel":
			slave.assignment = "work in the brothel";
			slave.assignmentVisible = 0;
			V.brothelSlaves++;
			V.BrothiIDs.push(slave.ID);
			switch (V.brothelDecoration) {
				case "Degradationist":
				case "standard":
					slave.livingRules = "spare";
					break;
				default:
					slave.livingRules = "normal";
					break;
			}
			break;

		case "be confined in the cellblock":
		case "cellblock":
			slave.assignment = "be confined in the cellblock";
			slave.assignmentVisible = 0;
			V.cellblockSlaves++;
			V.CellBiIDs.push(slave.ID);
			switch (V.cellblockDecoration) {
				case "Paternalist":
					slave.livingRules = "normal";
					break;
				default:
					slave.livingRules = "spare";
					break;
			}
			break;

		case "get treatment in the clinic":
		case "clinic":
			slave.assignment = "get treatment in the clinic";
			slave.assignmentVisible = 0;
			V.clinicSlaves++;
			V.CliniciIDs.push(slave.ID);
			switch (V.clinicDecoration) {
				case "Repopulation Focus":
				case "Eugenics":
				case "Gender Radicalist":
				case "Gender Fundamentalist":
				case "Paternalist":
				case "Maturity Preferentialist":
				case "Youth Preferentialist":
				case "Slimness Enthusiast":
				case "Hedonistic":
				case "Intellectual Dependency":
				case "Petite Admiration":
				case "Statuesque Glorification":
					slave.livingRules = "luxurious";
					break;

				case "Roman Revivalist":
				case "Aztec Revivalist":
				case "Egyptian Revivalist":
				case "Arabian Revivalist":
				case "Chinese Revivalist":
				case "Chattel Religionist":
				case "Edo Revivalist":
					slave.livingRules = "normal";
					break;

				default:
					slave.livingRules = "spare";
					break;
			}
			break;

		case "serve in the club":
		case "club":
			slave.assignment = "serve in the club";
			slave.assignmentVisible = 0;
			V.clubSlaves++;
			V.ClubiIDs.push(slave.ID);
			slave.livingRules = "normal";
			break;

		case "work in the dairy":
		case "dairy":
			slave.assignment = "work in the dairy";
			slave.assignmentVisible = 0;
			V.dairySlaves++;
			V.DairyiIDs.push(slave.ID);
			switch (V.dairyDecoration) {
				case "Roman Revivalist":
				case "Aztec Revivalist":
				case "Chinese Revivalist":
				case "Chattel Religionist":
				case "Edo Revivalist":
				case "Arabian Revivalist":
				case "Egyptian Revivalist":
				case "Supremacist":
				case "Subjugationist":
				case "Degradationist":
					slave.livingRules = "spare";
					break;
				default:
					slave.livingRules = "normal";
					break;
			}
			break;

		case "work as a farmhand":
		case "farmyard":
			slave.assignment = "work as a farmhand";
			slave.assignmentVisible = 0;
			V.farmyardSlaves++;
			V.FarmyardiIDs.push(slave.ID);
			switch (V.farmyardDecoration) {
				case "Aztec Revivalist":
				case "Chinese Revivalist":
				case "Chattel Religionist":
				case "Edo Revivalist":
				case "Arabian Revivalist":
				case "Egyptian Revivalist":
				case "Supremacist":
				case "Subjugationist":
				case "Degradationist":
					slave.livingRules = "spare";
					break;
				case "Roman Revivalist":
					slave.livingRules = "luxurious";
					break;
				default:
					slave.livingRules = "normal";
					break;
			}
			break;

		case "live with your head girl":
		case "head girl suite":
		case "hgsuite":
			slave.assignment = "live with your Head Girl";
			slave.assignmentVisible = 0;
			V.HGSuiteSlaves++;
			V.HGSuiteiIDs.push(slave.ID);
			slave.livingRules = "luxurious";
			break;

		case "serve in the master suite":
		case "master suite":
		case "mastersuite":
			slave.assignment = "serve in the master suite";
			slave.assignmentVisible = 0;
			V.masterSuiteSlaves++;
			V.MastSiIDs.push(slave.ID);
			if (V.masterSuiteUpgradeLuxury > 0) {
				slave.livingRules = "luxurious";
			} else {
				slave.livingRules = "normal";
			}
			break;

		case "learn in the schoolroom":
		case "schoolroom":
			slave.assignment = "learn in the schoolroom";
			slave.assignmentVisible = 0;
			V.schoolroomSlaves++;
			V.SchlRiIDs.push(slave.ID);
			slave.livingRules = "normal";
			break;

		case "work as a servant":
		case "servants' quarters":
		case "servantsquarters":
			slave.assignment = "work as a servant";
			slave.assignmentVisible = 0;
			V.servantsQuartersSlaves++;
			V.ServQiIDs.push(slave.ID);
			switch (V.servantsQuartersDecoration) {
				case "Roman Revivalist":
				case "Aztec Revivalist":
				case "Chinese Revivalist":
				case "Chattel Religionist":
				case "Edo Revivalist":
				case "Supremacist":
				case "Subjugationist":
				case "Degradationist":
				case "Arabian Revivalist":
				case "Egyptian Revivalist":
					slave.livingRules = "spare";
					break;
				case "Slave Professionalism":
					if (slave.intelligence + slave.intelligenceImplant > 15) {
						slave.livingRules = "normal";
					} else {
						slave.livingRules = "spare";
					}
					break;
				case "Petite Admiration":
					if (heightPass(slave)) {
						slave.livingRules = "normal";
					} else {
						slave.livingRules = "spare";
					}
					break;
				case "Statuesque Glorification":
					if (heightPass(slave)) {
						slave.livingRules = "normal";
					} else {
						slave.livingRules = "spare";
					}
					break;
				default:
					slave.livingRules = "normal";
					break;
			}
			break;

		case "rest in the spa":
		case "spa":
			slave.assignment = "rest in the spa";
			slave.assignmentVisible = 0;
			V.spaSlaves++;
			V.SpaiIDs.push(slave.ID);
			switch (V.spaDecoration) {
				case "Chattel Religionist":
				case "Chinese Revivalist":
					slave.livingRules = "normal";
					break;
				case "Degradationist":
					slave.livingRules = "spare";
					break;
				default:
					slave.livingRules = "luxurious";
					break;
			}
			break;

		case "work as a nanny":
		case "nursery":
			slave.assignment = "work as a nanny";
			slave.assignmentVisible = 0;
			V.nurserySlaves++;
			V.NurseryiIDs.push(slave.ID);
			slave.livingRules = "normal";
			break;

		case "be the attendant":
		case "be the matron":
		case "be the dj":
		case "be the madam":
		case "be the milkmaid":
		case "be the farmer":
		case "be the nurse":
		case "be the schoolteacher":
		case "be the stewardess":
		case "be the wardeness":
			slave.assignment = job;
			slave.assignmentVisible = 0; /* non-visible leadership roles */
			slave.livingRules = "luxurious";
			break;

		case "be your concubine":
			slave.assignment = job;
			slave.assignmentVisible = 0; /* non-visible leadership roles */
			if (V.masterSuiteUpgradeLuxury > 0) {
				slave.livingRules = "luxurious";
			} else {
				slave.livingRules = "normal";
			}
			break;

		case "be your head girl":
			slave.assignment = job;
			if (V.HGSuite === 1) {
				slave.livingRules = "luxurious";
			}
			break;

		case "guard you":
			slave.assignment = job;
			if (V.dojo > 1) {
				slave.livingRules = "luxurious";
			}
			if (V.pitBG === 1 && V.fighterIDs.includes(slave.ID)) { V.fighterIDs.delete(slave.ID); }
			break;

		case "be your agent":
		case "live with your agent":
			slave.assignment = job;
			slave.assignmentVisible = 0;
			slave.useRulesAssistant = 0; /* non-visible roles exempt from Rules Assistant */
			WombCleanGenericReserve(slave, 'incubator', 9999);
			WombCleanGenericReserve(slave, 'nursery', 9999);
			if (job === "be your agent") {
				V.leaders.push(slave);
				App.activeArcology().leaderID = slave.ID;
				App.activeArcology().government = "your agent";
			}
			break;

		case "choose her own job":
			slave.assignment = job;
			slave.choosesOwnAssignment = 1; /* removeJob already set assignmentVisible = 1 */
			break;

		default:
			slave.assignment = job; /* removeJob already set assignmentVisible = 1 and choosesOwnAssignment = 0 */
			break;
	}

	if (slave.assignmentVisible === 0 && Array.isArray(V.personalAttention)) {
		if (V.personalAttention.deleteWith(s => s.ID === slave.ID).length > 0) {
			if (V.personalAttention.length === 0) {
				if (V.PC.career === "escort") {
					V.personalAttention = "whoring";
				} else if (V.PC.career === "servant") {
					V.personalAttention = "upkeep";
				} else {
					V.personalAttention = "business";
				}
				r += `${slave.slaveName} no longer has your personal attention; you plan to focus on ${V.personalAttention}.`;
			} else {
				r += `${slave.slaveName} no longer has your personal attention.`;
			}
		}
	}
	V.JobIDArray = resetJobIDArray();
	if (idx >= 0) { V.slaves[idx] = slave; }

	return r;
};

window.removeJob = function removeJob(slave, assignment) {
	"use strict";
	const V = State.variables;
	let r = "";

	const idx = V.slaveIndices[slave.ID];

	if (assignment === "Pit") {
		V.fighterIDs.delete(slave.ID);
	} else if (assignment === "Coursing Association") {
		V.Lurcher = 0;
	} else {
		if (V.HeadGirl !== 0 && slave.ID === V.HeadGirl.ID) {
			V.HeadGirl = 0;
		} else if (V.Recruiter !== 0 && slave.ID === V.Recruiter.ID) {
			V.Recruiter = 0;
		} else if (V.Bodyguard !== 0 && slave.ID === V.Bodyguard.ID) {
			V.Bodyguard = 0;
		} else if (V.Madam !== 0 && slave.ID === V.Madam.ID) {
			V.Madam = 0;
		} else if (V.DJ !== 0 && slave.ID === V.DJ.ID) {
			V.DJ = 0;
		} else if (V.Milkmaid !== 0 && slave.ID === V.Milkmaid.ID) {
			V.Milkmaid = 0;
		} else if (V.Farmer !== 0 && slave.ID === V.Farmer.ID) {
			V.Farmer = 0;
		} else if (V.Schoolteacher !== 0 && slave.ID === V.Schoolteacher.ID) {
			V.Schoolteacher = 0;
		} else if (V.Attendant !== 0 && slave.ID === V.Attendant.ID) {
			V.Attendant = 0;
		} else if (V.Matron !== 0 && slave.ID === V.Matron.ID) {
			V.Matron = 0;
		} else if (V.Nurse !== 0 && slave.ID === V.Nurse.ID) {
			V.Nurse = 0;
		} else if (V.Stewardess !== 0 && slave.ID === V.Stewardess.ID) {
			V.Stewardess = 0;
		} else if (V.Wardeness !== 0 && slave.ID === V.Wardeness.ID) {
			V.Wardeness = 0;
		} else if (V.Concubine !== 0 && slave.ID === V.Concubine.ID) {
			V.Concubine = 0;
		} else if (V.Collectrix !== 0 && slave.ID === V.Collectrix.ID) {
			V.Collectrix = 0;
		}

		/* use .toLowerCase() to get rid of a few dupe conditions. */
		switch (assignment.toLowerCase()) {
			case "be confined in the arcade":
			case "arcade":
				slave.assignment = "work a glory hole";
				V.ArcadeiIDs.delete(slave.ID);
				V.arcadeSlaves--;
				break;

			case "work in the brothel":
			case "brothel":
				slave.assignment = "whore";
				V.BrothiIDs.delete(slave.ID);
				V.brothelSlaves--;
				break;

			case "be confined in the cellblock":
			case "cellblock":
				slave.assignment = "rest";
				if (slave.inflation > 0) {
					slave.inflation = 0;
					slave.inflationType = "none";
					slave.inflationMethod = 0;
					SetBellySize(slave);
				}
				V.CellBiIDs.delete(slave.ID);
				V.cellblockSlaves--;
				break;

			case "get treatment in the clinic":
			case "clinic":
				slave.assignment = "rest";
				V.CliniciIDs.delete(slave.ID);
				V.clinicSlaves--;
				break;

			case "serve in the club":
			case "club":
				slave.assignment = "serve the public";
				V.ClubiIDs.delete(slave.ID);
				V.clubSlaves--;
				break;

			case "work in the dairy":
			case "dairy":
				slave.assignment = "get milked";
				V.DairyiIDs.delete(slave.ID);
				V.dairySlaves--;
				break;

			case "work as a farmhand":
			case "farmyard":
				slave.assignment = "rest";
				V.FarmyardiIDs.delete(slave.ID);
				V.farmyardSlaves--;
				break;

			case "learn in the schoolroom":
			case "schoolroom":
				slave.assignment = "rest";
				V.SchlRiIDs.delete(slave.ID);
				V.schoolroomSlaves--;
				break;

			case "rest in the spa":
			case "spa":
				slave.assignment = "rest";
				V.SpaiIDs.delete(slave.ID);
				V.spaSlaves--;
				break;

			case "work as a servant":
			case "servants' quarters":
			case "servantsquarters":
				slave.assignment = "be a servant";
				V.ServQiIDs.delete(slave.ID);
				V.servantsQuartersSlaves--;
				break;

			case "serve in the master suite":
			case "master suite":
			case "mastersuite":
				slave.assignment = "please you";
				V.MastSiIDs.delete(slave.ID);
				V.masterSuiteSlaves--;
				break;

			case "live with your head girl":
			case "head girl suite":
			case "hgsuite":
				slave.assignment = "rest";
				V.HGSuiteiIDs.delete(slave.ID);
				V.HGSuiteSlaves--;
				break;

			case "work as a nanny":
			case "nursery":
				slave.assignment = "rest";
				V.NurseryiIDs.delete(slave.ID);
				V.nurserySlaves--;
				break;

			case "be your head girl":
				let attentionCheck = 1;
				slave.assignment = "rest";
				const HGSlave = V.slaves.findIndex(s => s.assignment === "live with your Head Girl");
				if (HGSlave !== -1) {
					if (V.HGSuiteEquality === 1) {
						if (V.slaves[HGSlave].devotion > 50) {
							removeJob(V.slaves[HGSlave], "live with your Head Girl");
							assignJob(V.slaves[HGSlave], "be your Head Girl");
							V.HeadGirl = V.slaves[HGSlave];
							V.slaves[HGSlave].diet = "healthy";
							attentionCheck = 0;
						} else {
							removeJob(V.slaves[HGSlave], "live with your Head Girl");
						}
					} else {
						removeJob(V.slaves[HGSlave], "live with your Head Girl");
					}
				}
				if (V.personalAttention === "HG" && attentionCheck === 1) {
					if (V.PC.career === "escort") {
						V.personalAttention = "whoring";
					} else if (V.PC.career === "servant") {
						V.personalAttention = "upkeep";
					} else {
						V.personalAttention = "business";
					}

					r += `You no longer have a slave assigned to be your Head Girl, so you turn your personal attention to focus on ${V.personalAttention}.`;
				}
				break;

			case "be your agent":
			case "live with your agent":
				if (slave.assignment === "be your agent") {
					App.activeArcology().leaderID = 0;
					App.activeArcology().government = "your trustees";
				}
				slave.assignment = "rest";
				V.leaders.deleteWith(s => s.ID === slave.ID);
				if (slave.relationshipTarget > 0) {
					/* following code assumes there can be at most one companion */
					const _lover = V.slaves.findIndex(s => haveRelationshipP(s, slave) && s.assignment === "live with your agent");
					if (_lover !== -1) {
						V.slaves[_lover].assignment = "rest";
						V.slaves[_lover].assignmentVisible = 1;
					}
				}
				break;

			default:
				slave.assignment = "rest";
				break;
		}

		if (slave.livingRules === "luxurious" && slave.assignmentVisible !== 1) {
			slave.livingRules = "normal";
		}

		slave.assignmentVisible = 1;
		slave.choosesOwnAssignment = 0;
		slave.sentence = 0;
	}
	V.JobIDArray = resetJobIDArray();
	if (idx >= 0) {
		V.slaves[idx] = slave;
	}

	return r;
};

window.resetJobIDArray = function resetJobIDArray() {
	/* todo: expand to all assignments */
	const slaves = State.variables.slaves;
	const JobIDArray = {
		"rest": [],
		"please you": [],
		"work a glory hole": [],
		"take classes": [],
		"be a servant": [],
		"whore": [],
		"serve the public": [],
		"get milked": [],
		"stay confined": [],
		"be a subordinate slave": []
	};

	slaves.forEach(function(slave) {
		if (JobIDArray.hasOwnProperty(slave.assignment)) {
			JobIDArray[slave.assignment].push(slave.ID);
		}
	});

	return JobIDArray;
};

/**
 * Generates string with links for changing slave assignment
 */
App.UI.jobLinks = function() {
	"use strict";
	const facilitiesOrder = [
		/* sorted by improvement before work, within improvement in order of progress, within work alphabetical for facilities*/
		App.Entity.facilities.penthouse,
		App.Entity.facilities.cellblock,
		App.Entity.facilities.nursery,
		App.Entity.facilities.schoolroom,
		App.Entity.facilities.clinic,
		App.Entity.facilities.spa,
		App.Entity.facilities.arcade,
		App.Entity.facilities.brothel,
		App.Entity.facilities.club,
		App.Entity.facilities.dairy,
		App.Entity.facilities.farmyard,
		App.Entity.facilities.masterSuite,
		App.Entity.facilities.servantsQuarters
	];

	return {
		assignments: assignmentLinks,
		transfers: transferLinks,
		assignmentsFragment: assignmentsFragment,
		transfersFragment: transfersFragment
	};

	/**
	 * Generates assignment links
	 * @param {number} index in the slaves array or -1 for the activeSlave
	 * @param {string} [passage] optional next passage to go to
	 * @param {linkCallback} [callback]
	 * @returns {string}
	 */
	function assignmentLinks(index, passage, callback) {
		let penthouseJobs = App.Entity.facilities.penthouse.assignmentLinks(index, undefined, passage, callback);
		const slave = App.Utils.slaveByIndex(index);
		const sp = getPronouns(slave);

		if (slave.fuckdoll === 0) {
			const assignment = "choose her own job";
			if (slave.assignment !== assignment) {
				const linkAction = callback !== undefined ? callback(assignment) : '';
				penthouseJobs.push(`<<link "Let ${sp.object} choose" ${passage !== undefined ? `"${passage}"` : ''}>><<= assignJob(${App.Utils.slaveRefString(index)}, "${assignment}")>>${linkAction}<</link>>`);
			}
		} else {
			penthouseJobs.push(App.UI.disabledLink(`Let ${sp.object} choose`, ["Fuckdolls can't choose their job"]));
		}

		return penthouseJobs.join("&thinsp;|&thinsp;");
	}

	function transferLinks(index) {
		/** @type {string[]} */
		const transfers = [];
		const slave = App.Utils.slaveByIndex(index);

		for (const f of facilitiesOrder) {
			if (!f.established) { continue; }
			const rejects = f.canHostSlave(slave);
			if (rejects.length === 0) {
				transfers.push(f.transferLink(index, undefined, passage()));
			} else {
				transfers.push(App.UI.disabledLink(f.genericName, rejects));
			}
		}

		return transfers.join('&thinsp;|&thinsp;');
	}

	/**
	 *
	 * @param {number} index
	 * @param {string} passage
	 * @param {assignmentCallback} [callback]
	 * @returns {DocumentFragment}
	 */
	function assignmentsFragment(index, passage, callback) {
		let penthouseJobs = App.Entity.facilities.penthouse.assignmentLinkElements(index, undefined, passage, callback);
		const slave = App.Utils.slaveByIndex(index);
		const sp = getPronouns(slave);

		if (slave.fuckdoll === 0) {
			const assignment = "choose her own job";
			if (slave.assignment !== assignment) {
				penthouseJobs.push(
					App.UI.DOM.assignmentLink(State.variables.slaves[index],
						assignment, passage, callback, `Let ${sp.object} choose`));
			}
		} else {
			penthouseJobs.push(App.UI.DOM.disabledLink(`Let ${sp.object} choose`, ["Fuckdolls can't choose their job"]));
		}
		let res = document.createDocumentFragment();
		// there is always at least one job
		res.appendChild(penthouseJobs[0]);
		for (let i = 1; i < penthouseJobs.length; ++i) {
			res.appendChild(document.createTextNode(" | "));
			res.appendChild(penthouseJobs[i]);
		}
		return res;
	}

	function transfersFragment(index) {
		/** @type {HTMLElement[]} */
		const transfers = [];
		const slave = App.Utils.slaveByIndex(index);

		for (const f of facilitiesOrder) {
			if (!f.established) { continue; }
			const rejects = f.canHostSlave(slave);
			if (rejects.length === 0) {
				transfers.push(f.transferLinkElement(index, undefined, passage()));
			} else {
				transfers.push(App.UI.DOM.disabledLink(f.genericName, rejects));
			}
		}

		let res = document.createDocumentFragment();
		// there is always at least one job
		res.appendChild(transfers[0]);
		for (let i = 1; i < transfers.length; ++i) {
			res.appendChild(document.createTextNode(" | "));
			res.appendChild(transfers[i]);
		}
		return res;
	}
}();

App.UI.SlaveInteract = {
	fucktoyPref: function() {
		let res = "";
		/** @type {App.Entity.SlaveState} */
		const slave = State.variables.activeSlave;
		const {his} = getPronouns(slave);
		if ((slave.assignment === "please you") || (slave.assignment === "serve in the master suite") || (slave.assignment === "be your Concubine")) {
			res += `__Fucktoy use preference__: <strong><span id = "hole">${slave.toyHole}</span></strong>.`;
			/** @type {string[]} */
			let links = [];
			links.push('<<link "Mouth">><<set $activeSlave.toyHole = "mouth">><<replace "#hole">>$activeSlave.toyHole<</replace>><</link>>');
			links.push('<<link "Tits">><<set $activeSlave.toyHole = "boobs">><<replace "#hole">>$activeSlave.toyHole<</replace>><</link>>');
			if ((slave.vagina > 0) && canDoVaginal(slave)) {
				links.push('<<link "Pussy">><<set $activeSlave.toyHole = "pussy">><<replace "#hole">>$activeSlave.toyHole<</replace>><</link>>');
			} else if (slave.vagina === 0) {
				links.push(App.UI.disabledLink("Pussy",
					[`Take ${his} virginity before giving ${his} pussy special attention`]));
			}
			if ((slave.anus > 0) && canDoAnal(slave)) {
				links.push('<<link "Ass">><<set $activeSlave.toyHole = "ass">><<replace "#hole">>$activeSlave.toyHole<</replace>><</link>>');
			} else {
				links.push(App.UI.disabledLink("Ass",
					[`Take ${his} anal virginity before giving ${his} ass special attention`]));
			}
			if ((slave.dick > 0) && canPenetrate(slave)) {
				links.push('<<link "Dick">><<set $activeSlave.toyHole = "dick">><<replace "#hole">>$activeSlave.toyHole<</replace>><</link>>');
			}
			links.push(`<<link "No Preference">><<set $activeSlave.toyHole = "all ${his} holes">><<replace "#hole">>$activeSlave.toyHole<</replace>><</link>>`);
			res += links.join('&thinsp;|&thinsp;') + '<br>';
		}
		App.UI.replace('#fucktoypref', res);
	},

	assignmentBlock: function(blockId) {
		let res = App.UI.jobLinks.assignments(-1, undefined, () => {
			return `<<replace "#assign">>$activeSlave.assignment<</replace>><<replace "#${blockId}">><<= App.UI.SlaveInteract.assignmentBlock("${blockId}")>><<= App.UI.SlaveInteract.fucktoyPref()>><</replace>>`;
		});
		if (State.variables.activeSlave.assignment !== "choose her own job") {
			res += '&thinsp;|&thinsp; <<link "Stay on this assignment for another month">><<set $activeSlave.sentence += 4>><<replace "#assign">>$activeSlave.assignment($activeSlave.sentence weeks)<</replace>><</link>>';
		}
		return res;
	}
};

App.activeArcology = function() {
	const V = State.variables;
	return V.arcologies[V.activeArcologyIdx];
};

App.currentAgent = function() {
	const V = State.variables, T = State.temporary;
	for (let j = 0; j < V.leaders.length; j++) {
		if (V.arcologies[T.currentNeighbor].leaderID === V.leaders[j].ID) {
			T.Agent = V.leaders[j];
		}
	}
};
