App.Medicine.Modification = {};
/**
 * Basic application of scar
 * @param {App.Entity.SlaveState} slave
 * @param {string} scar
 *  @param {string} design
 *  @param {string} weight
 */
App.Medicine.Modification.addScar = function(slave, scar, design, weight) {
	/* const V = State.variables;
	V.scarApplied = 1;
	V.degradation += 10;
	slave.health -= 10; //dangerous to uncomment this as sometimes many scars are applied at once.
	cashX(forceNeg(surgery.costs), "slaveSurgery", slave);
	slave.health -= (V.PC.medicine >= 100) ? Math.round(surgery.healthCosts / 2) : surgery.healthCosts;*/
	if (!weight) {
		weight = 1;
	}
	if (!slave.scar.hasOwnProperty(scar)) {
		slave.scar[scar] = new App.Entity.scarState();
	}
	if (!slave.scar[scar].hasOwnProperty(design)) {
		slave.scar[scar][design] = weight;
	} else {
		slave.scar[scar][design] += weight;
	}
};
/**
 * Basic application of scar
 * @param {App.Entity.SlaveState} slave
 * @param {string} scar
 * @param {string} design
 */
App.Medicine.Modification.removeScar = function(slave, scar, design) {
	/* const V = State.variables;
	V.scarApplied = 1;
	V.degradation += 10;
	slave.health -= 10; //dangerous to uncomment this as sometimes many scars are applied at once.
	cashX(forceNeg(surgery.costs), "slaveSurgery", slave);
	slave.health -= (V.PC.medicine >= 100) ? Math.round(surgery.healthCosts / 2) : surgery.healthCosts;*/
	if (slave.scar.hasOwnProperty(scar)) {  // if scar object exists for this body part
		if (slave.scar[scar].hasOwnProperty(design)) {  // if object has this kind of scar (might be custom)
			if (["generic", "whip", "chain", "burn", "menacing", "exotic", "surgical", "c-section", "cutting"].includes(design)) {
				slave.scar[scar][design] = 0;
			} else {
				delete slave.scar[scar][design]; // scar was custom
			}
		}
		// remove the scar object entirely if no entry is scarred:
		let weights = Object.values(slave.scar[scar]);
		let total = 0;
		let i;
		for (i = 0; i < weights.length; i++) {
			total += weights[i];
		}
		if (total === 0) {
			delete slave.scar[scar];
		}
	}
};

/**
 * Slave is whipped over the entire body, and strains in manacles so much that the wrists and ankles scar if present.
 * @param {App.Entity.SlaveState} slave
 *  @param {string} weight
 */
App.Medicine.Modification.addScourged = function(slave, weight) {
	let scarArray = ["left breast", "right breast", "back", "lower back", "left buttock", "right buttock"];
	let i = 0;
	// Whip
	if (slave.amp !== 1) {
		scarArray.push("left upper arm", "right upper arm", "left thigh", "right thigh");
	}
	for (i = 0; i < scarArray.length; i++) {
		App.Medicine.Modification.addScar(slave, scarArray[i], "whip", weight);
	}
	// Manacles
	if (slave.amp !== 1) {
		scarArray = ["left wrist", "right wrist", "left ankle", "right ankle"];
		for (i = 0; i < scarArray.length; i++) {
			App.Medicine.Modification.addScar(slave, scarArray[i], "chain", weight);
		}
	}
};
